/**
 *******************************************************************************
 * @file       OsArch.h
 * @version    V1.1.4
 * @date       2011.04.20
 * @brief      Implement function declare related to Cortex-M3(ARM-v7)
 * @details    This header file including functions or defines related to
 *             Cortex-M3(ARM-v7).
 *******************************************************************************
 * @copy
 *
 * INTERNAL FILE,DON'T PUBLIC.
 *
 * <h2><center>&copy; COPYRIGHT 2009 CooCox </center></h2>
 *******************************************************************************
 */


#ifndef  _CPU_H
#define  _CPU_H

#include <stdint.h>
#include "common.h"

/*!< Initial System tick.	*/
#define InitSysTick()   SysTick_Config(20000);

/*!< Initial priorities.	*/
#define InitInt()   \
  NVIC_SetPriority(PendSV_IRQn, 15); \
  NVIC_SetPriority(SysTick_IRQn, 15);


/*---------------------------- Variable declare ------------------------------*/
extern U64      OSTickCnt;          /*!< Counter for current system ticks.    */

/*!< Initial context of task being created	*/
extern OS_STK  *InitTaskContext(FUNCPtr task,void *param,OS_STK *pstk);
extern void    SwitchContext(void);         /*!< Switch context                   */
extern void    SetEnvironment(OS_STK *pstk);/*!< Set environment for run          */
extern U8      Inc8 (volatile U8 *data);
extern U8      Dec8 (volatile U8 *data);
extern void    IRQ_ENABLE_RESTORE(void);
extern void    IRQ_DISABLE_SAVE(void);
#endif
